/**
 * Created by CSL on 2017/5/5.
 * 辅助定额调整。
 */

var mongoose = require("mongoose");
var dbm = require("../../../config/db/db_manager");
var db = dbm.getCfgConnection("rationRepository")

// eg:重庆CQJZDE-2008,P28,AA0116机械装运土方全程运距100米内（主定额）20米内(会根据用户实际录入值变化)，AA0117每增加10米（辅助定额）。
// 建筑中的主定额只有一条辅助定额。（公路的主定额会对应多条辅助定额）
var assistSchema = mongoose.Schema({
    libID: Number,                      // 所属定额定ID
    mainRationID: Number,               // 主定额ID
    assistRationID: Number,             // 辅助定额ID
    assistDisplayName: String,          // 辅助定额显示名称 （eg:每增加10米）
    minValue: String,                   // 下限值（eg:20）
    maxValue: String,                   // 上限值（eg:100，也可能没有）
    stepValue: String                   // 步距值 (eg:10)
});

var assistModel = db.model("rationAssists",assistSchema, "rationAssists")

var assistDAO = function(){};

assistDAO.prototype.getAssist = function (data, callback) {
    assistModel.findOne({
            "libID": data.libID,
            "mainRationID": data.mainRationID,
            "$or": [{"isDeleted": null}, {"isDeleted": false}]
        },
        function (err, doc) {
            if (err) callback(true, "获取辅助定额错误！", "")
            else callback(false, "获取辅助定额成功", doc);
        })
};

// test datas.
//function callbackExec(err) {if (err) {console.log(err);} else {console.log('saved.')};};
//assistModel.create({"libID": 1, "mainRationID":1, assistRationID: 2, assistDisplayName: "每增加10米", minValue:"20", maxValue: "100", stepValue:"10"}, callbackExec);
//assistModel.create({"libID": 1, "mainRationID":3, assistRationID: 4, assistDisplayName: "每增加100米", minValue:"200", maxValue: "500", stepValue:"100"}, callbackExec);
//assistModel.create({"libID": 1, "mainRationID":5, assistRationID: 6, assistDisplayName: "每增加100米", minValue:"1000", maxValue: null, stepValue:"1000"}, callbackExec);


module.exports = new assistDAO();